var SESSION_STATUS = Flashphoner.constants.SESSION_STATUS;
var STREAM_STATUS = Flashphoner.constants.STREAM_STATUS;
var session;
var url = "https://demo.flashphoner.com:8444/rest-api";
var PRELOADER_URL = "https://github.com/flashphoner/flashphoner_client/raw/wcs_api-2.0/examples/demo/dependencies/media/preloader.mp4";


function init_api() {
    Flashphoner.init({});
    //Connect to WCS server over websockets
    session = Flashphoner.createSession({
        urlServer: "wss://demo.flashphoner.com" //specify the address of your WCS
    }).on(SESSION_STATUS.ESTABLISHED, function(session) {
        console.log("ESTABLISHED");
    });

    startBtn.onclick = startTranscoding;
    playBtn.onclick = playClick;
}

function startTranscoding() {
    fetchUrl = url + "/transcoder/startup";
    const options = {
        method: "POST",
        headers: {
            "Content-Type": "application/json"
        },
        body: JSON.stringify({
            "uri": "transcoder://tcode1",
            "localStreamName": "testT",
            "remoteStreamName": document.getElementById("stream").value,
            "encoder": {
                "width": 640,
                "height": 480,
                "keyFrameInterval": 30,
                "fps": 30
            }
        }),
    }
    fetch(fetchUrl, options);
}

var Browser = {
    isSafari: function() {
        return /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    },
}

function playClick() {
    if (Browser.isSafari()) {
        Flashphoner.playFirstVideo(document.getElementById("localVideo"), true, PRELOADER_URL).then(function() {
            playStream(session);
        });
    } else {
        playStream(session);
    }
}

function playStream() {
    var options = {
        name: "testT",
        display: document.getElementById("myVideo")
    };
    var stream = session.createStream(options)
        .on(STREAM_STATUS.PLAYING, function(stream) {});
    stream.play();
}